diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
index 2553bf9ae..e2873835b 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityBoat.java
@@ -4,7 +4,7 @@ import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityFlag;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
@@ -15,14 +15,15 @@ import net.minecraft.core.util.helper.BlockParticleHelper;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.List;
 
-public class EntityBoat extends Entity
-{
+public class EntityBoat extends Entity {
     private static final double MAX_BOAT_SPEED = 0.8D;
     private static final double ACCELERATION = 0.0065D;
     private static final float MAX_ROTATION_SPEED = 5f;
@@ -48,104 +49,90 @@ public class EntityBoat extends Entity
     public TileEntityFlag tileEntityFlag = null;
 
 
-    public EntityBoat(World world)
-    {
+    public EntityBoat(World world) {
         super(world);
-        boatCurrentDamage = 0;
-        boatTimeSinceHit = 0;
-        boatRockDirection = 1;
-        blocksBuilding = true;
+        this.boatCurrentDamage = 0;
+        this.boatTimeSinceHit = 0;
+        this.boatRockDirection = 1;
+        this.blocksBuilding = true;
         setSize(1.5F, 0.6F);
-        heightOffset = bbHeight / 2.0F;
-        sendAdditionalData = true;
+        this.heightOffset = this.bbHeight / 2.0F;
+        this.sendAdditionalData = true;
     }
 
-    private void createTileEntity()
-    {
+    private void createTileEntity() {
         if (this.flag == null) return;
         this.tileEntityFlag = new TileEntityFlag();
         CompoundTag flagData = this.flag.getData().getCompoundOrDefault("FlagData", null);
-        if (flagData != null)
-        {
+        if (flagData != null) {
             this.tileEntityFlag.readAdditionalData(flagData);
         }
     }
 
     @Override
-	protected boolean makeStepSound()
-    {
+    protected boolean makeStepSound() {
         return false;
     }
 
     @Override
-	protected void defineSynchedData()
-    {
+    protected void defineSynchedData() {
     }
 
     @Override
-	public AABB getBb()
-    {
-        return bb;
+    public @Nullable AABBdc getCollisionAABB() {
+        return this.bb;
     }
 
     @Override
-	public boolean isPushable()
-    {
+    public boolean isPushable() {
         return true;
     }
 
-    public EntityBoat(World world, double d, double d1, double d2)
-    {
+    public EntityBoat(@NotNull World world, double x, double y, double z) {
         this(world);
-        setPos(d, d1 + (double) heightOffset, d2);
-        xd = 0.0D;
-        yd = 0.0D;
-        zd = 0.0D;
-        xo = d;
-        yo = d1;
-        zo = d2;
+        setPos(x, y + (double) this.heightOffset, z);
+        this.xd = 0.0D;
+        this.yd = 0.0D;
+        this.zd = 0.0D;
+        this.xo = x;
+        this.yo = y;
+        this.zo = z;
     }
 
     @Override
-	public double getRideHeight()
-    {
-        return (double) bbHeight * 0.0D - 0.3D;
+    public double getRideHeight() {
+        return (double) this.bbHeight * 0.0D - 0.3D;
     }
+
     @Override
-    public boolean hurt(Entity entity, int i, DamageType type)
-    {
-        int numParticles = random.nextInt(8) + 1;
-        for (int q = 0; q < numParticles; q++)
-        {
-            world.spawnParticle("block", x, y, z, xd, yd, zd, BlockParticleHelper.encodeBlockData(Blocks.PLANKS_OAK.id(), 0, Side.BOTTOM));
+    public boolean hurt(Entity entity, int i, DamageType type) {
+        int numParticles = this.random.nextInt(8) + 1;
+        for (int q = 0; q < numParticles; q++) {
+            this.world.spawnParticle("block", this.x, this.y, this.z, this.xd, this.yd, this.zd, BlockParticleHelper.encodeBlockData(Blocks.PLANKS_OAK.id(), 0, Side.BOTTOM));
         }
-        if(world.isClientSide || removed)
-        {
+        if (this.world.isClientSide || this.removed) {
             return true;
         }
-        if(entity instanceof Player) {
-        	if(((Player) entity).getGamemode() == Gamemode.creative) {
-        		remove();
-                if (this.flag != null)
-                {
+        if (entity instanceof Player player) {
+            if (player.getGamemode() == Gamemode.creative) {
+                remove();
+                if (this.flag != null) {
                     dropItem(this.flag.copy(), 0.0F);
                 }
                 return true;
-        	}
+            }
         }
-        boatRockDirection = -boatRockDirection;
-        boatTimeSinceHit = 10;
-        boatCurrentDamage += i * 10;
+        this.boatRockDirection = -this.boatRockDirection;
+        this.boatTimeSinceHit = 10;
+        this.boatCurrentDamage += i * 10;
         markHurt();
-        if(boatCurrentDamage > 40)
-        {
-            if(passenger != null)
-            {
-                passenger.startRiding(this);
+        if (this.boatCurrentDamage > 40) {
+            if (this.passenger != null) {
+                this.passenger.startRiding(this);
             }
-            if(entity instanceof Player){
+            if (entity instanceof Player) {
                 dropItem(Items.BOAT.id, 1, 0.0F);
-            }else {
+            } else {
                 for (int j = 0; j < 3; j++) {
                     dropItem(Blocks.PLANKS_OAK.id(), 1, 0.0F);
                 }
@@ -154,8 +141,7 @@ public class EntityBoat extends Entity
                     dropItem(Items.STICK.id, 1, 0.0F);
                 }
             }
-            if (this.flag != null)
-            {
+            if (this.flag != null) {
                 dropItem(this.flag.copy(), 0.0F);
             }
 
@@ -165,12 +151,12 @@ public class EntityBoat extends Entity
     }
 
     @Override
-    public void remove(){
-        Entity entity = passenger;
+    public void remove() {
+        Entity entity = this.passenger;
 
-        if (entity != null){
-            double bbCenterX = (bb.minX + bb.maxX)/2;
-            double bbCenterZ = (bb.minZ + bb.maxZ)/2;
+        if (entity != null) {
+            double bbCenterX = (this.bb.minX + this.bb.maxX) / 2;
+            double bbCenterZ = (this.bb.minZ + this.bb.maxZ) / 2;
 
             this.passenger = null;
             entity.vehicle = null;
@@ -181,166 +167,148 @@ public class EntityBoat extends Entity
     }
 
     @Override
-	public void animateHurt()
-    {
-        boatRockDirection = -boatRockDirection;
-        boatTimeSinceHit = 10;
-        boatCurrentDamage += boatCurrentDamage * 10;
+    public void animateHurt() {
+        this.boatRockDirection = -this.boatRockDirection;
+        this.boatTimeSinceHit = 10;
+        this.boatCurrentDamage += this.boatCurrentDamage * 10;
     }
 
     @Override
-	public boolean isPickable()
-    {
-        return !removed;
+    public boolean isPickable() {
+        return !this.removed;
     }
 
     @Override
-	public void lerpTo(double x, double y, double z, float yRot,
-                       float xRot, int i)
-    {
-        lerpX = x;
-        lerpY = y;
-        lerpZ = z;
-        boatPitch = xRot;
-        lerpTicks = i;
+    public void lerpTo(double x, double y, double z, float yRot,
+                       float xRot, int i) {
+        this.lerpX = x;
+        this.lerpY = y;
+        this.lerpZ = z;
+        this.boatPitch = xRot;
+        this.lerpTicks = i;
         // Don't interpolate velocity from server when controlling the boat
-        if (passenger != null && !passenger.lerpVehicleMotion()) return;
-        lerpYRot = yRot;
-        xd = velocityX;
-        yd = velocityY;
-        zd = velocityZ;
+        if (this.passenger != null && !this.passenger.lerpVehicleMotion()) return;
+        this.lerpYRot = yRot;
+        this.xd = this.velocityX;
+        this.yd = this.velocityY;
+        this.zd = this.velocityZ;
     }
 
     @Override
-	public void lerpMotion(double xd, double yd, double zd)
-    {
+    public void lerpMotion(double xd, double yd, double zd) {
         // Don't interpolate velocity from server when controlling the boat
-        if (passenger != null && !passenger.lerpVehicleMotion()) return;
-        velocityX = this.xd = xd;
-        velocityY = this.yd = yd;
-        velocityZ = this.zd = zd;
+        if (this.passenger != null && !this.passenger.lerpVehicleMotion()) return;
+        this.velocityX = this.xd = xd;
+        this.velocityY = this.yd = yd;
+        this.velocityZ = this.zd = zd;
     }
+
     @Override
-	public void tick()
-    {
-        setRot(yRot, xRot);
+    public void tick() {
+        setRot(this.yRot, this.xRot);
         super.tick();
-        if(boatTimeSinceHit > 0)
-        {
-            boatTimeSinceHit--;
+        if (this.boatTimeSinceHit > 0) {
+            this.boatTimeSinceHit--;
         }
-        if(boatCurrentDamage > 0)
-        {
-            boatCurrentDamage--;
+        if (this.boatCurrentDamage > 0) {
+            this.boatCurrentDamage--;
         }
-        xo = x;
-        yo = y;
-        zo = z;
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
         final int waterSections = 5;
         double bouyancy = 0.0D;
         boolean inWater = false;
-        for(int i = 0; i < waterSections; i++) // Splits the boat into individual sections to measure how submerged it is, 1 being fully submerged, 0 being fully exposed
+        for (int i = 0; i < waterSections; i++) // Splits the boat into individual sections to measure how submerged it is, 1 being fully submerged, 0 being fully exposed
         {
-            double minY = (bb.minY + ((bb.maxY - bb.minY) * (double)(i)) / (double)waterSections) - 0.125D;
-            double maxY = (bb.minY + ((bb.maxY - bb.minY) * (double)(i + 1)) / (double)waterSections) - 0.125D;
-            AABB axisalignedbb = AABB.fromPool(bb.minX, minY, bb.minZ, bb.maxX, maxY, bb.maxZ);
-            if(world.isAABBInMaterial(axisalignedbb, Material.water))
-            {
-                bouyancy += 1.0D / (double)waterSections;
+            double minY = (this.bb.minY + ((this.bb.maxY - this.bb.minY) * (double) (i)) / (double) waterSections) - 0.125D;
+            double maxY = (this.bb.minY + ((this.bb.maxY - this.bb.minY) * (double) (i + 1)) / (double) waterSections) - 0.125D;
+            AABBdc aabb = new AABBd(this.bb.minX, minY, this.bb.minZ, this.bb.maxX, maxY, this.bb.maxZ);
+            if (this.world.isAABBInMaterial(aabb, Materials.WATER)) {
+                bouyancy += 1.0D / (double) waterSections;
                 inWater = true;
             }
         }
 
-        if(world.isClientSide)
-        {
-            if(lerpTicks > 0)
-            {
-                double lerpX = x + (this.lerpX - x) / (double) lerpTicks;
-                double lerpY = y + (this.lerpY - y) / (double) lerpTicks;
-                double lerpZ = z + (this.lerpZ - z) / (double) lerpTicks;
-                xRot += (boatPitch - xRot) / lerpTicks;
-                if (passenger == null || passenger.lerpVehicleMotion()){
+        if (this.world.isClientSide) {
+            if (this.lerpTicks > 0) {
+                double lerpX = this.x + (this.lerpX - this.x) / (double) this.lerpTicks;
+                double lerpY = this.y + (this.lerpY - this.y) / (double) this.lerpTicks;
+                double lerpZ = this.z + (this.lerpZ - this.z) / (double) this.lerpTicks;
+                this.xRot += (this.boatPitch - this.xRot) / this.lerpTicks;
+                if (this.passenger == null || this.passenger.lerpVehicleMotion()) {
                     float lerpYRot;
-                    lerpYRot = MathHelper.normalizeRotation(this.lerpYRot - yRot);
-                    yRot += lerpYRot / lerpTicks;
+                    lerpYRot = MathHelper.normalizeRotation(this.lerpYRot - this.yRot);
+                    this.yRot += lerpYRot / this.lerpTicks;
                 }
-                lerpTicks--;
+                this.lerpTicks--;
                 setPos(lerpX, lerpY, lerpZ);
             }
             boatMovement();
-            move(xd , yd, zd);
-            setRot(yRot, xRot);
-            xd *= 0.99D;
-            yd *= 0.95D;
-            zd *= 0.99D;
+            move(this.xd, this.yd, this.zd);
+            setRot(this.yRot, this.xRot);
+            this.xd *= 0.99D;
+            this.yd *= 0.95D;
+            this.zd *= 0.99D;
             return;
         }
-        if(bouyancy < 1.0D)
-        {
-            yd += 0.04D * (bouyancy * 2D - 1.0D);
-        } else
-        {
-            if(yd < 0.0D)
-            {
-                yd /= 2D;
+        if (bouyancy < 1.0D) {
+            this.yd += 0.04D * (bouyancy * 2D - 1.0D);
+        } else {
+            if (this.yd < 0.0D) {
+                this.yd /= 2D;
             }
-            yd += 0.007D;
+            this.yd += 0.007D;
         }
 
         boatMovement();
 
-        if (passenger == null){
-            float nextYRot = yRot;
-            if(Math.hypot(xd, zd) > 0.001D)
-            {
-                nextYRot = (float)Math.toDegrees(Math.atan2(zd, xd)) + 180;
+        if (this.passenger == null) {
+            float nextYRot = this.yRot;
+            if (Math.hypot(this.xd, this.zd) > 0.001D) {
+                nextYRot = (float) Math.toDegrees(Math.atan2(this.zd, this.xd)) + 180;
             }
             float changeInYRot;
-            changeInYRot = MathHelper.normalizeRotation(nextYRot - yRot);
+            changeInYRot = MathHelper.normalizeRotation(nextYRot - this.yRot);
             changeInYRot = MathHelper.clamp(changeInYRot, -20F, 20F);
-            yRot = MathHelper.normalizeRotation(yRot + changeInYRot);
-            setRot(yRot, xRot);
+            this.yRot = MathHelper.normalizeRotation(this.yRot + changeInYRot);
+            setRot(this.yRot, this.xRot);
         }
 
-        move(xd, yd, zd);
-        double horizontalSpeed = Math.sqrt(xd * xd + zd * zd);
-        if(inWater && horizontalSpeed > 0.15D)
-        {
-            double d12 = Math.cos(((double) yRot * Math.PI) / 180D);
-            double d15 = Math.sin(((double) yRot * Math.PI) / 180D);
-            for(int i1 = 0; (double)i1 < 1.0D + horizontalSpeed * 60D; i1++)
-            {
-                double d18 = random.nextFloat() * 2.0F - 1.0F;
-                double d20 = (double)(random.nextInt(2) * 2 - 1) * 0.6D;
-                if(random.nextBoolean())
-                {
-                    double posX = (x - d12 * d18 * 0.8D) + d15 * d20;
-                    double posZ = z - d15 * d18 * 0.8D - d12 * d20;
-                    world.spawnParticle("splash", posX, y - 0.125D, posZ, xd, yd, zd, 0);
-                } else
-                {
-                    double posX = x + d12 + d15 * d18 * 0.7D;
-                    double posZ = (z + d15) - d12 * d18 * 0.7D;
-                    world.spawnParticle("splash", posX, y - 0.125D, posZ, xd, yd, zd, 0);
+        move(this.xd, this.yd, this.zd);
+        double horizontalSpeed = Math.sqrt(this.xd * this.xd + this.zd * this.zd);
+        if (inWater && horizontalSpeed > 0.15D) {
+            double d12 = Math.cos(((double) this.yRot * Math.PI) / 180D);
+            double d15 = Math.sin(((double) this.yRot * Math.PI) / 180D);
+            for (int i1 = 0; (double) i1 < 1.0D + horizontalSpeed * 60D; i1++) {
+                double d18 = this.random.nextFloat() * 2.0F - 1.0F;
+                double d20 = (double) (this.random.nextInt(2) * 2 - 1) * 0.6D;
+                if (this.random.nextBoolean()) {
+                    double posX = (this.x - d12 * d18 * 0.8D) + d15 * d20;
+                    double posZ = this.z - d15 * d18 * 0.8D - d12 * d20;
+                    this.world.spawnParticle("splash", posX, this.y - 0.125D, posZ, this.xd, this.yd, this.zd, 0);
+                } else {
+                    double posX = this.x + d12 + d15 * d18 * 0.7D;
+                    double posZ = (this.z + d15) - d12 * d18 * 0.7D;
+                    this.world.spawnParticle("splash", posX, this.y - 0.125D, posZ, this.xd, this.yd, this.zd, 0);
                 }
             }
 
         }
 
-        if (passenger == null || !passenger.deferVehicleBehavior()){
-            xd *= 0.99D;
-            yd *= 0.95D;
-            zd *= 0.99D;
+        if (this.passenger == null || !this.passenger.deferVehicleBehavior()) {
+            this.xd *= 0.99D;
+            this.yd *= 0.95D;
+            this.zd *= 0.99D;
         }
 
-        xRot = 0.0F;
+        this.xRot = 0.0F;
 
         // Push entities in bounding box
-        List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, bb.grow(0.2D, 0.0D, 0.2D));
-        if(list != null && !list.isEmpty())
-        {
+        List<Entity> list = this.world.getEntitiesWithinAABBExcludingEntity(this, MathHelper.aabbGrow(this.bb, 0.2D, 0.0D, 0.2D, new AABBd()));
+        if (!list.isEmpty()) {
             for (Entity entity : list) {
-                if (entity != passenger && entity.isPushable() && (entity instanceof EntityBoat)) {
+                if (entity != this.passenger && entity.isPushable() && (entity instanceof EntityBoat)) {
                     entity.push(this);
                 }
             }
@@ -348,114 +316,107 @@ public class EntityBoat extends Entity
         }
 
         // Break snow layers on the ground
-        for(int i = 0; i < 4; i++)
-        {
-            int blockX = MathHelper.floor(x + ((double)(i % 2) - 0.5D) * 0.8D);
-            int blockY = MathHelper.floor(y);
-            int blockZ = MathHelper.floor(z + ((double)(i / 2) - 0.5D) * 0.8D);
-            Block<?> block = world.getBlock(blockX, blockY, blockZ);
-            if(block != null && block.hasTag(BlockTags.BOAT_BREAKS))
-            {
-                world.setBlockWithNotify(blockX, blockY, blockZ, 0);
+        for (int i = 0; i < 4; i++) {
+            int blockX = MathHelper.floor(this.x + ((double) (i % 2) - 0.5D) * 0.8D);
+            int blockY = MathHelper.floor(this.y);
+            int blockZ = MathHelper.floor(this.z + ((double) (i / 2) - 0.5D) * 0.8D);
+            Block<?> block = this.world.getBlock(blockX, blockY, blockZ);
+            if (block != null && block.hasTag(BlockTags.BOAT_BREAKS)) {
+                this.world.setBlockWithNotify(blockX, blockY, blockZ, 0);
             }
         }
 
         // Remove passenger is passenger removal is queued
-        if(passenger != null && passenger.removed)
-        {
-            passenger = null;
+        if (this.passenger != null && this.passenger.removed) {
+            this.passenger = null;
         }
     }
-    public void boatMovement(){
-        double boatRad = Math.toRadians(yRot + 90);
-        double vectorRad = Math.atan2(xd, zd);
+
+    public void boatMovement() {
+        double boatRad = Math.toRadians(this.yRot + 90);
+        double vectorRad = Math.atan2(this.xd, this.zd);
         double currentBoatSpeed;
-        if (passenger != null){
+        if (this.passenger != null) {
             boolean isBackwards = Math.cos(-boatRad - vectorRad) < 0;
             double ang = vectorRad + boatRad + (isBackwards ? Math.PI : 0);
 
-            double _xd = xd;
-            xd = _xd * Math.cos(ang) - zd * Math.sin(ang);
-            zd = _xd * Math.sin(ang) + zd * Math.cos(ang);
+            double _xd = this.xd;
+            this.xd = _xd * Math.cos(ang) - this.zd * Math.sin(ang);
+            this.zd = _xd * Math.sin(ang) + this.zd * Math.cos(ang);
         }
 
         double xdOff;
         double zdOff;
-        currentBoatSpeed = Math.hypot(xd, zd);
-        if(passenger != null) {
-            passenger.handleSpecialVehicleControl();
+        currentBoatSpeed = Math.hypot(this.xd, this.zd);
+        if (this.passenger != null) {
+            this.passenger.handleSpecialVehicleControl();
         }
-        yRot += pendingYRot;
-        pendingYRot = 0;
-        xdOff = pendingXDChange;
-        zdOff = pendingZDChange;
-        pendingXDChange = 0;
-        pendingZDChange = 0;
+        this.yRot += this.pendingYRot;
+        this.pendingYRot = 0;
+        xdOff = this.pendingXDChange;
+        zdOff = this.pendingZDChange;
+        this.pendingXDChange = 0;
+        this.pendingZDChange = 0;
 
         double offsetMagnitude = Math.hypot(xdOff, zdOff);
-        double vecAngle = Math.acos((xd * xdOff + zd * zdOff)/ ((currentBoatSpeed + 0.00000000001D) * (offsetMagnitude + 0.00000000001D)));
-        double multiplier = (1 + (vecAngle/Math.PI)); // Increase acceleration if it runs opposite to the current motion vector
+        double vecAngle = Math.acos((this.xd * xdOff + this.zd * zdOff) / ((currentBoatSpeed + 0.00000000001D) * (offsetMagnitude + 0.00000000001D)));
+        double multiplier = (1 + (vecAngle / Math.PI)); // Increase acceleration if it runs opposite to the current motion vector
         xdOff *= multiplier;
         zdOff *= multiplier;
 
 //        System.out.printf("%f %f\n", xdOff, zdOff);
 
-        xd += xdOff;
-        zd += zdOff;
+        this.xd += xdOff;
+        this.zd += zdOff;
 
-        if(passenger != null) {
-            passenger.sendSpecialVehiclePacket();
+        if (this.passenger != null) {
+            this.passenger.sendSpecialVehiclePacket();
         }
 
         // Cap max speed properly
-        currentBoatSpeed = Math.hypot(xd, zd);
-        if (currentBoatSpeed > MAX_BOAT_SPEED){
-            xd = xd/currentBoatSpeed * MAX_BOAT_SPEED;
-            zd = zd/currentBoatSpeed * MAX_BOAT_SPEED;
+        currentBoatSpeed = Math.hypot(this.xd, this.zd);
+        if (currentBoatSpeed > MAX_BOAT_SPEED) {
+            this.xd = this.xd / currentBoatSpeed * MAX_BOAT_SPEED;
+            this.zd = this.zd / currentBoatSpeed * MAX_BOAT_SPEED;
         }
 
-        if(onGround)
-        {
-            xd *= 0.5D;
-            yd *= 0.5D;
-            zd *= 0.5D;
+        if (this.onGround) {
+            this.xd *= 0.5D;
+            this.yd *= 0.5D;
+            this.zd *= 0.5D;
         }
     }
 
-    public void controlBoat(float forward, float strafe){
-        double currentBoatSpeed = Math.hypot(xd, zd);
-        pendingYRot = (float) (strafe * (MIN_ROTATION_SPEED + (MAX_ROTATION_SPEED - MIN_ROTATION_SPEED) * Math.max(((MAX_BOAT_SPEED - (currentBoatSpeed * 1.5))/ MAX_BOAT_SPEED), 0))); // I love interpolation
+    public void controlBoat(float forward, float strafe) {
+        double currentBoatSpeed = Math.hypot(this.xd, this.zd);
+        this.pendingYRot = (float) (strafe * (MIN_ROTATION_SPEED + (MAX_ROTATION_SPEED - MIN_ROTATION_SPEED) * Math.max(((MAX_BOAT_SPEED - (currentBoatSpeed * 1.5)) / MAX_BOAT_SPEED), 0))); // I love interpolation
         float velOff = (float) (forward * ACCELERATION);
-        pendingXDChange = Math.cos(Math.toRadians(yRot)) * velOff;
-        pendingZDChange = Math.sin(Math.toRadians(yRot)) * velOff;
+        this.pendingXDChange = Math.cos(Math.toRadians(this.yRot)) * velOff;
+        this.pendingZDChange = Math.sin(Math.toRadians(this.yRot)) * velOff;
     }
 
-    public void handleControlDirect(float xd, float zd, float yRot){
+    public void handleControlDirect(float xd, float zd, float yRot) {
         this.yRot = (float) MathHelper.clamp(yRot, this.yRot - MAX_PACKET_ROTATION_CHANGE, this.yRot + MAX_PACKET_ROTATION_CHANGE);
         this.xd = MathHelper.clamp(xd, this.xd - MAX_PACKET_SPEED_CHANGE, this.xd + MAX_PACKET_SPEED_CHANGE);
         this.zd = MathHelper.clamp(zd, this.zd - MAX_PACKET_SPEED_CHANGE, this.zd + MAX_PACKET_SPEED_CHANGE);
     }
 
     @Override
-	public void positionRider()
-    {
-        if (passenger != null) {
-            double d = Math.cos(((double) yRot * Math.PI) / 180D) * 0.4D;
-            double d1 = Math.sin(((double) yRot * Math.PI) / 180D) * 0.4D;
-            passenger.setPos(x + d, y + getRideHeight() + passenger.getRidingHeight(), z + d1);
+    public void positionRider() {
+        if (this.passenger != null) {
+            double d = Math.cos(((double) this.yRot * Math.PI) / 180D) * 0.4D;
+            double d1 = Math.sin(((double) this.yRot * Math.PI) / 180D) * 0.4D;
+            this.passenger.setPos(this.x + d, this.y + getRideHeight() + this.passenger.getRidingHeight(), this.z + d1);
         }
     }
 
     @Override
     public void waterHurt() {
-        return;
     }
 
     @Override
-    public void addAdditionalSaveData(@NotNull CompoundTag tag)
-    {
-        if (this.flag != null)
-        {
+    public void addAdditionalSaveData(@NotNull CompoundTag tag) {
+        if (this.flag != null) {
             CompoundTag flagTag = new CompoundTag();
             this.flag.writeToNBT(flagTag);
             tag.put("Flag", flagTag);
@@ -463,10 +424,8 @@ public class EntityBoat extends Entity
     }
 
     @Override
-	public void readAdditionalSaveData(@NotNull CompoundTag tag)
-    {
-        if (tag.containsKey("Flag"))
-        {
+    public void readAdditionalSaveData(@NotNull CompoundTag tag) {
+        if (tag.containsKey("Flag")) {
             CompoundTag flagTag = tag.getCompound("Flag");
             this.flag = ItemStack.readItemStackFromNbt(flagTag);
             createTileEntity();
@@ -474,62 +433,59 @@ public class EntityBoat extends Entity
     }
 
     @Override
-	public float getShadowHeightOffs()
-    {
+    public float getShadowHeightOffs() {
         return 0.0F;
     }
 
     @Override
-	public boolean interact(@NotNull Player player)
-    {
-        if(passenger != null && (passenger instanceof Player) && passenger != player)
-        {
+    public boolean interact(@NotNull Player player) {
+        if (this.passenger != null && (this.passenger instanceof Player) && this.passenger != player) {
             return true;
         }
-        if(!world.isClientSide)
-        {
-            if (player.getHeldItem() != null && player.getHeldItem().itemID == Items.FLAG.id && flag == null)
-            {
+        if (!this.world.isClientSide) {
+            if (player.getHeldItem() != null && player.getHeldItem().itemID == Items.FLAG.id && this.flag == null) {
                 this.flag = player.getHeldItem().copy();
                 player.inventory.setItem(player.inventory.getCurrentItemIndex(), null);
                 createTileEntity();
-                world.sendTrackedEntityDataPacket(this);
+                this.world.sendTrackedEntityDataPacket(this);
                 return true;
             }
             player.startRiding(this);
         }
         return true;
     }
+
     @Override
     public Entity ejectRider() {
-        Entity entity = passenger;
-        if(entity == null) return null;
+        Entity entity = this.passenger;
+        if (entity == null) return null;
 
         this.passenger = null;
         entity.vehicle = null;
 
-        double bbCenterX = (bb.minX + bb.maxX)/2;
-        double bbCenterY = (bb.minY + bb.maxY)/2;
-        double bbCenterZ = (bb.minZ + bb.maxZ)/2;
+        double bbCenterX = (this.bb.minX + this.bb.maxX) / 2;
+        double bbCenterY = (this.bb.minY + this.bb.maxY) / 2;
+        double bbCenterZ = (this.bb.minZ + this.bb.maxZ) / 2;
 
         boolean flag = false;
         for (int i = 0; i < 4; i++) {
             final double length = 1.75D;
-            double angle = Math.toRadians(yRot - 90) + (Math.PI/2) * i;
+            double angle = Math.toRadians(this.yRot - 90) + (Math.PI / 2) * i;
             double checkX = bbCenterX + Math.cos(angle) * length;
             double checkZ = bbCenterZ + Math.sin(angle) * length;
             entity.moveTo(checkX, this.bb.maxY + 0.1, checkZ, entity.yRot, entity.xRot);
-            if (/*world.checkIfAABBIsClear(entity.bb) && */world.getCubes(entity, entity.bb).isEmpty()){
+            if (/*world.checkIfAABBIsClear(entity.bb) && */this.world.getCubes(entity, entity.bb).isEmpty()) {
                 flag = true;
                 break;
             }
         }
-        if (!flag){
+        if (!flag) {
             entity.moveTo(bbCenterX, this.bb.maxY + 0.1, bbCenterZ, entity.yRot, entity.xRot);
         }
         return entity;
     }
 
     @Override
-    protected void causeFallDamage(float distance){}
+    protected void causeFallDamage(float distance) {
+    }
 }
